//
//  FGHudButtonCell.m
//
//  Created by Francesco on 1/9/06.
//  Copyright 2006 Softech di Germinara Francesco
//
//  www.germinara.it
//  info@germinara.it
//
//  All rights reserved.
/////////////////////////////////////////////////////////


#import "FGHudButtonCell.h"
#import "FGNSBezierPathAddition.h"

@implementation FGHudButtonCell

- (id) init {
	self = [super init];
	if (self != nil) {
     [self setButtonType:NSMomentaryPushInButton];
	 bIsHighlighted=NO;
	 aImageButton=[[NSImage  imageNamed:@"samplebutton1.tiff"] retain];
	 aImageButtonPressedOn=[[NSImage  imageNamed:@"samplebutton1.tiff"] retain];
	 aImageButtonDisabledOn=[[NSImage  imageNamed:@"samplebutton1.tiff"] retain];
	 aImageButtonOff=[[NSImage  imageNamed:@"samplebutton1.tiff"] retain];
	 aImageButtonPressedOff=[[NSImage  imageNamed:@"samplebutton1.tiff"] retain];
	 aImageButtonDisabledOff=[[NSImage  imageNamed:@"samplebutton1.tiff"] retain];

	 nButtonType=0; //Image Button
	 theTitle=[[NSString alloc] initWithString:@"FgHudButton"];
	}
	return self;
}

- (void) dealloc {
	[aImageButton release];
	[aImageButtonPressedOn release];
	[aImageButtonDisabledOn release];
	[aImageButtonOff release];
	[aImageButtonPressedOff release];
	[aImageButtonDisabledOff release];
	[theTitle release];

	[super dealloc];
}

- (void)drawWithFrame:(NSRect)cellFrame inView:(NSView *)controlView
{

 NSRect rcInvalidate= [[self controlView] bounds];
 aHudView=(FGHUDView *)[[super controlView] superview];

 if(nButtonType==8){
  BOOL bEnabled=[self isEnabled];
  int bPressed=[self isHighlighted];
  BOOL bState=[self state];
  NSPoint pt;

  backColor=[aHudView clrBodyBar];
  [backColor set];
  NSRectFill(cellFrame);
  [self drawTextAtLeftTop:cellFrame]; 
 
  pt.x=cellFrame.origin.x;
  pt.y=cellFrame.origin.y-2;

 if(bEnabled && !bPressed && bState==NSOnState){ //-N-ON
  [aImageButton setFlipped: YES];
  [aImageButton drawAtPoint: pt fromRect: NSMakeRect(0,0,26,26) operation: NSCompositeSourceOver fraction: 1.0];
  [aImageButton setFlipped: NO];
 }

 if(bEnabled && !bPressed  && bState==NSOffState){ //-N-OFF
  [aImageButtonOff setFlipped: YES];
  [aImageButtonOff drawAtPoint: pt fromRect: NSMakeRect(0,0,26,26) operation: NSCompositeSourceOver fraction: 1.0];
  [aImageButtonOff setFlipped: NO];
 }

 if(bEnabled && bPressed && bState==NSOnState){ //-N-ON
  [aImageButtonPressedOn setFlipped: YES];
  [aImageButtonPressedOn drawAtPoint: pt fromRect: NSMakeRect(0,0,26,26) operation: NSCompositeSourceOver fraction: 1.0];
  [aImageButtonPressedOn setFlipped: NO];
 }

 if(bEnabled && bPressed  && bState==NSOffState){ //-N-OFF
  [aImageButtonPressedOff setFlipped: YES];
  [aImageButtonPressedOff drawAtPoint: pt fromRect: NSMakeRect(0,0,26,26) operation: NSCompositeSourceOver fraction: 1.0];
  [aImageButtonPressedOff setFlipped: NO];
 }

 if(!bEnabled && !bPressed  && bState==NSOnState){ //-D-ON
  [aImageButtonPressedOn setFlipped: YES];
  [aImageButtonPressedOn drawAtPoint: pt fromRect: NSMakeRect(0,0,26,26) operation: NSCompositeSourceOver fraction: 1.0];
  [aImageButtonPressedOn setFlipped: NO];
 }

 if(!bEnabled && !bPressed  && bState==NSOffState){ //-D-OFF
  [aImageButtonPressedOff setFlipped: YES];
  [aImageButtonPressedOff drawAtPoint: pt fromRect: NSMakeRect(0,0,26,26) operation: NSCompositeSourceOver fraction: 1.0];
  [aImageButtonPressedOff setFlipped: NO];
 }

   return;
 }


 if(nButtonType==6 || nButtonType==7){
  BOOL bEnabled=[self isEnabled];
  int bPressed=[self isHighlighted];
  BOOL bState=[self state];

  NSRect rectImage=cellFrame;

  backColor=[aHudView clrBodyBar];

  [backColor set];
 
  NSRectFill(rcInvalidate);

  rectImage.size=[aImageButton size];
 
 if(bEnabled && !bPressed && bState==NSOnState){ //-N-ON
  [aImageButton setFlipped: YES];
  [aImageButton drawAtPoint: NSZeroPoint fromRect: rectImage operation: NSCompositeSourceOver fraction: 1.0];
  [aImageButton setFlipped: NO];
 }

 if(bEnabled && !bPressed  && bState==NSOffState){ //-N-OFF
  [aImageButtonOff setFlipped: YES];
  [aImageButtonOff drawAtPoint: NSZeroPoint fromRect: rectImage operation: NSCompositeSourceOver fraction: 1.0];
  [aImageButtonOff setFlipped: NO];
 }

 if(bEnabled && bPressed && bState==NSOnState){ //-N-ON
  [aImageButtonPressedOn setFlipped: YES];
  [aImageButtonPressedOn drawAtPoint: NSZeroPoint fromRect: rectImage operation: NSCompositeSourceOver fraction: 1.0];
  [aImageButtonPressedOn setFlipped: NO];
 }

 if(bEnabled && bPressed  && bState==NSOffState){ //-N-OFF
  [aImageButtonPressedOff setFlipped: YES];
  [aImageButtonPressedOff drawAtPoint: NSZeroPoint fromRect: rectImage operation: NSCompositeSourceOver fraction: 1.0];
  [aImageButtonPressedOff setFlipped: NO];
 }

 if(!bEnabled && !bPressed  && bState==NSOnState){ //-D-ON
  [aImageButtonPressedOn setFlipped: YES];
  [aImageButtonPressedOn drawAtPoint: NSZeroPoint fromRect: rectImage operation: NSCompositeSourceOver fraction: 1.0];
  [aImageButtonPressedOn setFlipped: NO];
 }

 if(!bEnabled && !bPressed  && bState==NSOffState){ //-D-OFF
  [aImageButtonPressedOff setFlipped: YES];
  [aImageButtonPressedOff drawAtPoint: NSZeroPoint fromRect: rectImage operation: NSCompositeSourceOver fraction: 1.0];
  [aImageButtonPressedOff setFlipped: NO];
 }
  return;
 }

 if(nButtonType==5){
  [super drawWithFrame:cellFrame  inView:controlView];
  [self drawText]; 
  return;
 }

 if(nButtonType==1 || nButtonType==2 || nButtonType==3){
  bIsHighlighted=[self state];
 }

 if(bIsHighlighted==YES){
  foreColor=[aHudView clrTitleBar];
  backColor=[aHudView clrBodyBar];
  
  if(nButtonType==2)
   [self setImageButtonWithName:@"fgcheckoff.tif"];
  if(nButtonType==3)
   [self setImageButtonWithName:@"fgcheckoff2.tif"];   
 }else{
  foreColor=[aHudView clrBodyBar];
  backColor=[aHudView clrTitleBar];
  
  if(nButtonType==2)
   [self setImageButtonWithName:@"fgcheckon.tif"];
  if(nButtonType==3)
   [self setImageButtonWithName:@"fgcheckon2.tif"];
 }

 [[aHudView clrBodyBar] set];
 NSRectFill(cellFrame);


 if((nButtonType!=2) && (nButtonType!=3)){
 [[NSColor blackColor] set];
 NSBezierPath *path = [NSBezierPath bezierPathWithRoundedRect:rcInvalidate cornerRadius:4];

 [path setFlatness:1.0];
 [path setLineWidth:1.0];
 if(bIsHighlighted==NO){
  [path bilinearGradientFillWithOuterColor:backColor innerColor:foreColor];
  [path stroke];
 }else{
  [[aHudView clrTitleBar] set];
  [path fill];
  [[NSColor blackColor] set];
  [path stroke];
 }
} 
 
 if(nButtonType<=3){ //IMAGE BUTTON
  [aImageButton setFlipped: YES];
  NSPoint pt;
  pt.x=cellFrame.origin.x+(rcInvalidate.size.width-15)/2;
  pt.y=cellFrame.origin.y+(rcInvalidate.size.height-15)/2;

   [aImageButton drawAtPoint: pt
              fromRect: NSMakeRect(0,0,15,15)
             operation: NSCompositeSourceOver
              fraction: 1.0];
			  
  [aImageButton setFlipped: NO];
 }
 
 if(nButtonType==4){
  [self drawText]; 
 }
}


- (void) highlight: (BOOL) flag  withFrame: (NSRect) cellFrame  inView: (NSView *) controlView
{

 if(nButtonType==6){
  [super highlight:flag  withFrame:cellFrame  inView:controlView];
 }

 if(nButtonType==5){
  [super highlight:flag  withFrame:cellFrame  inView:controlView];
  return;
 }

  bIsHighlighted=flag;
 [[self controlView] setNeedsDisplayInRect:cellFrame ];
}


-(void) setCellButtonType:(int)nType{
 NSRect rcInvalidate= [[self controlView] bounds];
 nButtonType=nType;
 
 if(nType==0){
  [self setButtonType:NSMomentaryPushInButton];
 }
 if(nType==1){
   [self setButtonType:NSPushOnPushOffButton];
 }
 if(nType==2 || nType==7){
   [self setButtonType:NSSwitchButton];
 }
 
 if(nType==3){
   [self setButtonType:NSSwitchButton];
 }
 if(nType==4){
  [self setButtonType:NSMomentaryPushInButton];
}
  
  if(nType==5){
  [self setButtonType:NSMomentaryPushInButton];
  [self setBezelStyle:NSRecessedBezelStyle];
 }
 
 if(nType==8){
   [self setButtonType:NSRadioButton];
 }
    
 [[self controlView] setNeedsDisplayInRect:rcInvalidate ];
}

-(void) setImageButtonWithName:(NSString *) newImageButton{
 NSRect rcInvalidate= [[self controlView] bounds];
 [aImageButton release];
 NSMutableString *tmpName=nil;

 //gestisco un massimo di 6 differenti immagini associate ai rispettivi stati e deve essere TIFF
 // il nome effettivo dell'immagine è la radice (newImageButton) + D + ON  (Disabilitato con stato a ON)
 // il nome effettivo dell'immagine è la radice (newImageButton) + D + OFF (Disabilitato con stato a OFF)
 // il nome effettivo dell'immagine è la radice (newImageButton) + N + ON  (Normale con stato a ON)
 // il nome effettivo dell'immagine è la radice (newImageButton) + N + OFF (Normale con stato a OFF)
 // il nome effettivo dell'immagine è la radice (newImageButton) + P + ON  (Premuto con stato a ON)
 // il nome effettivo dell'immagine è la radice (newImageButton) + P + OFF (Premuto con stato a OFF)

 tmpName=[NSMutableString stringWithFormat:@"%@-%@-%@.tiff",newImageButton,@"D",@"ON"];
 aImageButtonDisabledOn=[[NSImage  imageNamed:tmpName] retain];

 tmpName=[NSMutableString stringWithFormat:@"%@-%@-%@.tiff",newImageButton,@"N",@"ON"];
 aImageButton=[[NSImage  imageNamed:tmpName] retain];

 if(aImageButton == nil){
  aImageButton=[[NSImage  imageNamed:newImageButton] retain];
 }

 tmpName=[NSMutableString stringWithFormat:@"%@-%@-%@.tiff",newImageButton,@"P",@"ON"];
 aImageButtonPressedOn=[[NSImage  imageNamed:tmpName] retain];

 tmpName=[NSMutableString stringWithFormat:@"%@-%@-%@.tiff",newImageButton,@"D",@"OFF"];
 aImageButtonDisabledOff=[[NSImage  imageNamed:tmpName] retain];

 tmpName=[NSMutableString stringWithFormat:@"%@-%@-%@.tiff",newImageButton,@"N",@"OFF"];
 aImageButtonOff=[[NSImage  imageNamed:tmpName] retain];

 tmpName=[NSMutableString stringWithFormat:@"%@-%@-%@.tiff",newImageButton,@"P",@"OFF"];
 aImageButtonPressedOff=[[NSImage  imageNamed:tmpName] retain];

 [[self controlView] setNeedsDisplayInRect:rcInvalidate ];
}

-(void) setTitle:(NSString *) aString{
 [theTitle release];
 theTitle=[aString retain];
}

-(void) drawText{
 NSString *infoString = [NSString stringWithFormat:@"<span style=\"font-size: 10px; font-family: 'Lucida Grande'; color: #ffffff;\"><strong>%@</strong></span>",theTitle];
 NSAttributedString * attributedInfoString = [[NSAttributedString alloc] initWithHTML:[infoString dataUsingEncoding:NSASCIIStringEncoding] documentAttributes:NULL];
 NSPoint stringPoint;
 stringPoint.x =  [[self controlView] bounds].size.width / 2 - [attributedInfoString size].width / 2;
 stringPoint.y =  [[self controlView] bounds].origin.y+ ([[self controlView] bounds].size.height-[attributedInfoString size].height)/2;
 [attributedInfoString drawAtPoint:stringPoint];
 [attributedInfoString release];
}

-(void) drawTextAtLeftTop:(NSRect)cellFrame{
 NSString *infoString = [NSString stringWithFormat:@"<span style=\"font-size: 10px; font-family: 'Lucida Grande'; color: #ffffff;\"><strong>%@</strong></span>",theTitle];
 NSAttributedString * attributedInfoString = [[NSAttributedString alloc] initWithHTML:[infoString dataUsingEncoding:NSASCIIStringEncoding] documentAttributes:NULL];
 NSPoint stringPoint;
 stringPoint.x =  cellFrame.origin.x+30;
 stringPoint.y =  cellFrame.origin.y+2;
 [attributedInfoString drawAtPoint:stringPoint];
 [attributedInfoString release];
}


@end
